local JPC = CreateFrame("Frame","JPC",UIParent)
local GetNumPartyMembers = GetNumGroupMembers
local usingRaidFrames = tonumber(GetCVar("useCompactPartyFrames"))
local spellBars = {}
local InArena = function() return (select(2,IsInInstance()) == "arena") end

hooksecurefunc("CompactRaidFrameContainer_SetFlowSortFunction", function(_,_)
		JPC:UpdateBars()
end)
function JPC:UpdateBars()
	local raidFramesOn = tonumber(GetCVar("useCompactPartyFrames"))
	for k,sp in ipairs(spellBars) do
		if (GetNumPartyMembers() > k)  then
			sp:ClearAllPoints()
			if (raidFramesOn == 1) or (UnitInRaid("player") and not InArena()) then
				for g =1,GetNumPartyMembers(),1 do
					local raidFrame = nil
					if CompactRaidFrameManager_GetSetting("KeepGroupsTogether") then
						if UnitInRaid("player") then
							raidFrame = _G["CompactRaidGroup1Member"..g]
						else
							raidFrame = _G["CompactPartyFrameMember"..g]
						end
					else
						raidFrame = _G["CompactRaidFrame"..g]
					end
					if raidFrame and (raidFrame.unitExists and UnitIsUnit(raidFrame.unit,"party"..k)) then
						sp:SetParent(raidFrame)
						sp:SetPoint("CENTER", raidFrame, "CENTER", 190, 0)
					end
				end
			else
				local partyFrame = _G["PartyMemberFrame"..k]
				if partyFrame and UnitIsUnit(partyFrame.unit,"party"..k) then
					sp:SetParent(partyFrame)
					sp:SetPoint("CENTER", partyFrame, "CENTER", 180, -30)
				end
			end
		end
	end
end
function JPC:GROUP_ROSTER_UPDATE()
	JPC:UpdateBars()
end
local function JPC_OnUpdate(self)
	if usingRaidFrames ~= tonumber(GetCVar("useCompactPartyFrames")) then
		usingRaidFrames = tonumber(GetCVar("useCompactPartyFrames"))
		self:UpdateBars()
	end
end
local function JPC_OnLoad(self)
	self:RegisterEvent("GROUP_ROSTER_UPDATE")
	self:SetScript("OnEvent",function(self,event,...) if self[event] then self[event](self,...) end end)
	for i=1,5 do
		local spellbar = CreateFrame("StatusBar", "raid"..i.."SpellBar", UIParent, "SmallCastingBarFrameTemplate");
		spellbar:SetScale(0.7)
		CastingBarFrame_SetUnit(spellbar, "party"..i, true, true);
		spellBars[i] = spellbar
	end
	JPC:UpdateBars()
	self:SetScript("OnUpdate",JPC_OnUpdate)
end
JPC:RegisterEvent("VARIABLES_LOADED")
JPC:SetScript("OnEvent",JPC_OnLoad)
--SLASH_JaxPartyCastbars1 = "/bd"
--SLASH_JaxPartyCastbars2 = "/bigdebuffs"
--SlashCmdList.JaxPartyCastbars = function(msg)
--
--end
--